// Simple DOPC Example (to make your own OPC Item)
// This example is based on Matrikon Simulation OPC Server
// You can download the server for free at: http://www.matrikon.com
// But it's a trivial matter to change to another OPC Server.
unit uMyItem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  dopc,Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    dOPCServer1: TdOPCServer;
    Panel1: TPanel;
    bConnect: TButton;
    procedure bConnectClick(Sender: TObject);
    procedure dOPCServer1Datachange(Sender: TObject; ItemList: TdOPCItemList);
  private
  public
  end;


  TmyOPCItem = class(TdOPCItem)
  private
    Test : string;
  public
    function GetTest : string;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TmyOPCItem.GetTest: string;
begin
  result := Test
end;

procedure AddMyItem(OPCGroup: TdOPCGroup; ItemStr: string);
var
  Item : TMyOPCItem;
begin
  Item := TmyOPCItem.create(OPCGroup.OPCItems);
  Item.ItemId := ItemStr;
  Item.Test   := 'Hallo';     // own property
  Item.OPCCommand(1);         // adds Item to opc server is aktive
end;

procedure TForm1.bConnectClick(Sender: TObject);
var
 G : TdOPCGroup;
begin
  with dOPCServer1 do
  begin
   ServerName := 'Matrikon.OPC.Simulation';
   G := OPCGroups.Add('test');
   G.OPCItems.AddItem('Random.Real8'); // normal Item
   AddMyItem(G,'Random.String');       // your Item
   Active := true;
  end;
end;

procedure TForm1.dOPCServer1Datachange(Sender: TObject;
  ItemList: TdOPCItemList);
var
  i : integer;
  s : string;
begin
  for i := 0 to ItemList.Count-1 do
  begin
    if ItemList[i] is TmyOPCItem then
      S := format('MyItem %s %s ',[TmyOPCItem(ItemList[i]).getTest,ItemList[i].ValueStr])
    else
      S := ItemList[i].ValueStr;
    Memo1.lines.add(S);
  end;
end;

end.
